#include <stdio.h>
#define SIZE 100

void median( int answer[] );           /* function prototype */

int main()
{ 

   /* array of responses */
   int response[ SIZE ] = { 6, 7, 8, 9, 8, 7, 8, 9, 8, 9,
                            7, 8, 9, 5, 9, 8, 7, 8, 7, 1,
                            6, 7, 8, 9, 3, 9, 8, 7, 1, 7,
                            7, 8, 9, 8, 9, 8, 9, 7, 1, 9,
                            6, 7, 8, 7, 8, 7, 9, 8, 9, 2,
                            7, 8, 9, 8, 9, 8, 9, 7, 5, 3,
                            5, 6, 7, 2, 5, 3, 9, 4, 6, 4,
                            7, 8, 9, 6, 8, 7, 8, 9, 7, 1,
                            7, 4, 4, 2, 5, 3, 8, 7, 5, 6,
                            4, 5, 6, 1, 6, 5, 7, 8, 7, 9};
   
   median( response ); /* process median */

   return 0; /* indicates successful termination */

} /* end main */



/*sort an array and determine median element's value */
void median( int answer[] )               
{ 
   int loop;     /* loop counter */
   int pass;     /* loop counter */
   int hold;     /* temporary variable for swapping */
   int firstRow; /* flag to indicate first row of array */
   
   printf( "\n%s\n%s\n%s\n", "******", "Median", "******" );
   printf( "The unsorted array of responses is\n" );
   
   /* display unsorted array */
   for ( loop = 0, firstRow = 1; loop <= SIZE - 1; loop++ ) { 

      /* start a new line */
      if ( loop % 20 == 0 && !firstRow ) {
         printf( "\n" );
      } /* end if */
         
      printf( "%2d", answer[ loop ] );
      firstRow = 0;
   } /* end for */
   
   printf( "\n\n" );
   
   /* sort array */
   for ( pass = 0; pass <= SIZE - 2; pass++ ) {

      /* compare elements and swap if necessary */
      for ( loop = 0; loop <= SIZE - 2; loop++ ) {

         /* swap elements */
         if ( answer[ loop ] > answer[ loop + 1 ] ) { 
            hold = answer[ loop ];
            answer[ loop ] = answer[ loop + 1 ];
            answer[ loop + 1 ] = hold;
         } /* end if */

      } /* end for */

   } /* end for */

   printf( "The sorted array is\n" );
   
   /* display sorted array */
   for ( loop = 0, firstRow = 1; loop <= SIZE - 1; loop++ ) { 

      /* start a new line */
      if ( loop % 20 == 0 && !firstRow ) {
         printf( "\n" );
      } /* end if */

      printf( "%2d", answer[ loop ] );
      firstRow = 0;
   } /* end for */
   
   printf( "\n\n" );

   /* even number of elements */
   if ( SIZE % 2 == 0 ) {     
      printf( "The median is the average of elements %d", 
         ( SIZE + 1 ) / 2 );
      printf( " and %d of", 1 + ( SIZE + 1 ) / 2 );
      printf( " the sorted %d element array.\n", SIZE );
      printf( "For this run the median is " );
      printf( "%.1f\n\n", ( double )( answer[ ( SIZE + 1 ) / 2 ] +
         answer[ ( SIZE + 1 ) / 2 + 1 ] ) / 2 );
   } /* end if */
   else { /* odd number of elements  */
      printf( "The median is element %d of ", ( SIZE + 1 ) / 2 );
      printf( "the sorted %d element array.\n", SIZE );
      printf( "For this run the median is " );
      printf( "%d\n\n", answer[ ( SIZE + 1 ) / 2 - 1 ] );
   } /* end else */

} /* end function median */



